﻿using System;

namespace Iterator
{
    class Arr:IContainer
    {
        Object[] buffer;
        readonly int max_element;        

        public Arr(int max_element)
        {
            this.max_element = max_element;
            buffer = new Object[max_element];
        }

        #region IContainer 멤버
        public bool  Add(object elem)
        {
            if(Count < max_element)
            {
                buffer[Count] = elem;
                Count++;
                return true;
            }
            return false;
        }
        public void  Remove(object elem)
        {
            int index = Find(elem);
            if (index == -1)
            {
                return;
            }
            Count--;
            for(int i =index; i<Count;i++)
            {
                buffer[i] = buffer[i+1];
            }            
        }
        public void Clear()
        {
            Count=0;
        }
        public int  Count
        {
            get;
            private set;
        }
        #endregion

        public class ArrIterator:IIterator
        {
            Object[] buffer;
            int bsize;
            int index;
            public ArrIterator(Object[] buffer, int bsize)
            {
                this.buffer = buffer;
                this.bsize = bsize;
            }
            #region IIterator 멤버
            void IIterator.Begin()
            {
                index = -1;
            }
            bool IIterator.MoveNext()
            {
                index++;
                if (index < bsize)
                {
                    return true;
                }
                return false;
            }
            object IIterator.Current
            {
                get { return buffer[index]; }
            }
            #endregion
        }
        public IIterator MakeIterator()
        {
            return new ArrIterator(buffer, Count);
        }
        int Find(Object elem)
        {
            int index=0;
            for( index=0 ; index < Count ; index++)
            {
                if(buffer[index] == elem)
                {
                    return index;
                }
            }
            return -1;
        }
    }
}
